package net.mcreator.morealtars.procedures;

import net.minecraftforge.items.ItemHandlerHelper;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.LightningBolt;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.core.BlockPos;

import net.mcreator.morealtars.init.MorealtarsModBlocks;

public class TransformerRightclickedOnBlockProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		if (Blocks.OBSIDIAN == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), MorealtarsModBlocks.ALTAR_OBSIDIAN.get().defaultBlockState(), 3);
		}
		if (Blocks.SHULKER_BOX == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.BLACK_SHULKER_BOX.defaultBlockState(), 3);
		}
		if (Blocks.BEDROCK == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock() && Blocks.BEDROCK == (world.getBlockState(BlockPos.containing(x, y - 1, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.OBSIDIAN.defaultBlockState(), 3);
		}
		if (Blocks.STONE == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), MorealtarsModBlocks.ALTAR_ROCK.get().defaultBlockState(), 3);
		}
		if (Blocks.DIAMOND_ORE == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.EMERALD_ORE.defaultBlockState(), 3);
		}
		if (Blocks.DEEPSLATE_DIAMOND_ORE == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.DEEPSLATE_EMERALD_ORE.defaultBlockState(), 3);
		}
		if (Blocks.CAMPFIRE == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.SOUL_CAMPFIRE.defaultBlockState(), 3);
		}
		if (Blocks.ANCIENT_DEBRIS == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock() && Blocks.GOLD_BLOCK == (world.getBlockState(BlockPos.containing(x, y - 1, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.AIR.defaultBlockState(), 3);
			world.setBlock(BlockPos.containing(x, y - 1, z), Blocks.AIR.defaultBlockState(), 3);
			if (entity instanceof Player _player) {
				ItemStack _setstack = new ItemStack(Items.NETHERITE_INGOT);
				_setstack.setCount(1);
				ItemHandlerHelper.giveItemToPlayer(_player, _setstack);
			}
		}
		if (Blocks.POTTED_WITHER_ROSE == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock() && Blocks.DIAMOND_BLOCK == (world.getBlockState(BlockPos.containing(x, y - 1, z))).getBlock()) {
			if (world instanceof ServerLevel _level) {
				LightningBolt entityToSpawn = EntityType.LIGHTNING_BOLT.create(_level);
				entityToSpawn.moveTo(Vec3.atBottomCenterOf(BlockPos.containing(x, y, z)));
				entityToSpawn.setVisualOnly(true);
				_level.addFreshEntity(entityToSpawn);
			}
			world.setBlock(BlockPos.containing(x, y, z), Blocks.WITHER_SKELETON_SKULL.defaultBlockState(), 3);
			world.setBlock(BlockPos.containing(x, y - 1, z), Blocks.IRON_BLOCK.defaultBlockState(), 3);
		}
		if (Blocks.DIAMOND_BLOCK == (world.getBlockState(BlockPos.containing(x, y, z))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.BEDROCK.defaultBlockState(), 3);
		}
		if (Blocks.OBSIDIAN == (world.getBlockState(BlockPos.containing(x + 1, y, z + 0))).getBlock() && Blocks.OBSIDIAN == (world.getBlockState(BlockPos.containing(x + -1, y, z + 0))).getBlock()
				&& Blocks.OBSIDIAN == (world.getBlockState(BlockPos.containing(x + 0, y, z + 1))).getBlock() && Blocks.OBSIDIAN == (world.getBlockState(BlockPos.containing(x + 0, y, z + -1))).getBlock()) {
			world.setBlock(BlockPos.containing(x, y, z), Blocks.AIR.defaultBlockState(), 3);
		}
	}
}
